﻿Option Strict On
Imports DialogFensterTest2.ViewModel.Services

Namespace Services

    Public Class DialogWindowService
        Implements IDialogWindowService
        Private _AktuellesFenster As View.DialogFenster
        Public Function ShowModalDialog(windowname As String, datacontext As Object, owner As Object, topMost As Boolean, showInTaskbar As Boolean, WindowStil As WindowStyle, Resize As ResizeMode, Width As Integer, AutoGroesse As SizeToContent, StartPosition As WindowStartupLocation, Titel As String) As Boolean Implements IDialogWindowService.ShowModalDialog
            Dim MeinFenster As New View.DialogFenster(windowname, datacontext, CType(AutoGroesse, Windows.SizeToContent), CType(StartPosition, Windows.WindowStartupLocation))
            _AktuellesFenster = MeinFenster
            MeinFenster.Topmost = topMost
            MeinFenster.ShowInTaskbar = showInTaskbar
            MeinFenster.WindowStyle = CType(WindowStil, Windows.WindowStyle)
            MeinFenster.ResizeMode = CType(Resize, Windows.ResizeMode)
            MeinFenster.Owner = MeinFenster.FindOwnerWindow(owner)
            MeinFenster.SizeToContent = CType(AutoGroesse, Windows.SizeToContent)
            Return CType(Application.Current.Dispatcher.Invoke(Function() MeinFenster.ShowDialog), Boolean)
        End Function

        Public Sub CloseDialog(vm As Object) Implements IDialogWindowService.CloseDialog
            Dim owner As Window = Application.Current.Windows.Cast(Of Window)().SingleOrDefault(Function(x) x.DataContext Is vm)
            If owner Is Nothing Then owner = Application.Current.Windows.Cast(Of Window)().SingleOrDefault(Function(x) x.DataContext IsNot Nothing AndAlso x.DataContext.GetType Is vm.GetType)

            If owner Is Nothing Then
                For Each window As Window In (From win In Application.Current.Windows()).ToList
                    If window.DataContext.GetType Is vm.GetType Then
                        window.Close()
                    End If
                Next
            Else
                owner.Close()
            End If
        End Sub

        Public Sub CloseDialog() Implements IDialogWindowService.CloseDialog
            If _AktuellesFenster IsNot Nothing Then
                _AktuellesFenster.Close()
            End If
        End Sub
    End Class
End Namespace