﻿Option Strict On

Imports System.Windows.Input
Imports DialogFensterTest2.ViewModel.Services

Public Class OKDialogViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase

    Private _Meldung As String
    Public Property Meldung() As String
        Get
            'If IsInDesignMode Then
            '    Return "Hier steht dann die Frage"
            'End If
            Return _Meldung
        End Get
        Set(ByVal value As String)
            _Meldung = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _OK As ICommand
    Public ReadOnly Property OK As ICommand
        Get
            If _OK Is Nothing Then _OK = New ViewModel.Instrastructure.RelayCommand(AddressOf OK_Execute)
            Return _OK
        End Get
    End Property

    Private Sub OK_Execute(obj As Object)
        Dim dialogService = ServiceContainer.GetService(Of IDialogWindowService)
        dialogService.CloseDialog(Me)
    End Sub
End Class
