﻿Option Strict On
Imports System.Windows.Input
Imports DialogFensterTest2.ViewModel.Services

Public Class JaNeinDialogViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase

    Private _Frage As String
    Public Property Frage() As String
        Get
            'If IsInDesignMode Then
            '    Return "Hier steht dann die Frage"
            'End If
            Return _Frage
        End Get
        Set(ByVal value As String)
            _Frage = value
            RaisePropertyChanged()
        End Set
    End Property



    Private _Ergebnis As Boolean
    Public Property Ergebnis() As Boolean
        Get
            Return _Ergebnis
        End Get
        Set(ByVal value As Boolean)
            _Ergebnis = value
            RaisePropertyChanged()
        End Set
    End Property


    Private _Ja As ICommand
    Public ReadOnly Property Ja As ICommand
        Get
            If _Ja Is Nothing Then _Ja = New ViewModel.Instrastructure.RelayCommand(AddressOf Ja_Execute)
            Return _Ja
        End Get
    End Property

    Private Sub Ja_Execute(obj As Object)
        Ergebnis = True
        Dim dialogService = ServiceContainer.GetService(Of IDialogWindowService)
        dialogService.CloseDialog()
    End Sub

    Private _Nein As ICommand
    Public ReadOnly Property Nein As ICommand
        Get
            If _Nein Is Nothing Then _Nein = New ViewModel.Instrastructure.RelayCommand(AddressOf Nein_Execute)
            Return _Nein
        End Get
    End Property

    Private Sub Nein_Execute(obj As Object)
        Ergebnis = False
        Dim dialogService = ServiceContainer.GetService(Of IDialogWindowService)
        dialogService.CloseDialog()
    End Sub
End Class
