﻿Option Strict On

Imports System.Drawing
Imports System.IO
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Threading


Public Class MainViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase


    Public Sub New()

        Hoehe = 250
        Breite = 500
        Bild = BitmapToImageSource(CType(Image.FromFile("C:\Users\alpha\Pictures\DSC_0214.JPG"), Bitmap))
    End Sub

    Private Function BitmapToImageSource(ByVal bitmap As Bitmap) As BitmapImage
        Using memory As MemoryStream = New MemoryStream()
            bitmap.Save(memory, System.Drawing.Imaging.ImageFormat.Bmp)
            memory.Position = 0
            Dim bitmapimage As BitmapImage = New BitmapImage()
            bitmapimage.BeginInit()
            bitmapimage.StreamSource = memory
            bitmapimage.CacheOption = BitmapCacheOption.OnLoad
            bitmapimage.EndInit()
            Return bitmapimage
        End Using
    End Function

    Private _Bild As ImageSource
    Public Property Bild As ImageSource
        Get
            Return _Bild
        End Get
        Set(value As ImageSource)
            _Bild = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Breite As Integer
    Public Property Breite As Integer
        Get
            Return _Breite
        End Get
        Set(value As Integer)
            _Breite = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Hoehe As Integer
    Public Property Hoehe As Integer
        Get
            Return _Hoehe
        End Get
        Set(value As Integer)
            _Hoehe = value
            RaisePropertyChanged()
        End Set
    End Property
End Class
